<?php
/**
 * Plugin Name: برای درگاه پرداخت بهبانک Easy Digital Downloads
 * Version: 1.0
 * Description: افزونه پرداخت بهبانک
 * Plugin URI: http://behbank.com
 * Author: epay123.ir
 */

if (!class_exists('GateWay')) {
    require_once('GateWay.php');
}

require'edd-currencies.php';


@session_start();

function mgw_edd_rial($formatted, $currency, $price)
{
    return $price . 'ریال';
}

function add_gateway_gateway($gateways)
{
    global $edd_options;
    $gateways['gateway'] = array(
        'admin_label' => 'بهبانک',
        'checkout_label' => strlen($edd_options['gateway_title']) ? $edd_options['gateway_title'] : 'درگاه پرداخت بهبانک',
    );
    return $gateways;
}
add_filter('edd_payment_gateways', 'add_gateway_gateway');

function gateway_cc_form()
{
    return;
}
add_action('edd_gateway_cc_form', 'gateway_cc_form');

function gateway_process($purchase_data)
{
    global $edd_options;

    $payment_data = array(
        'price' => $purchase_data['price'],
        'date' => $purchase_data['date'],
        'user_email' => $purchase_data['post_data']['edd_email'],
        'purchase_key' => $purchase_data['purchase_key'],
        'currency' => $edd_options['currency'],
        'downloads' => $purchase_data['downloads'],
        'cart_details' => $purchase_data['cart_details'],
        'user_info' => $purchase_data['user_info'],
        'status' => 'pending'
    );
    $payment = edd_insert_payment($payment_data);

    if ($payment) {
        @ delete_transient('edd_gateway_record');
        set_transient('edd_gateway_record', $payment);

        $_SESSION['edd_gateway_record'] = $payment;
        $callback = add_query_arg('verify', 'gateway', get_permalink($edd_options['success_page']));
        $amount = intval($payment_data['price']);
        $description = 'پرداخت صورت حساب ' . $purchase_data['purchase_key'];
        $merchant = $edd_options['gateway_merchant'];

		if ( edd_get_currency() == 'IRT' || $edd_options['currency'] == 'IRT' ) {
			$amount *= 10;
		}
		
        $gateWay = new GateWay();
        $params = array(
            'merchantCode' => $merchant,
            'amount' => $amount,
            'callBackUrl' => $callback,
            'invoiceNumber' => $payment,//$purchase_data['purchase_key'],
            'payerEmail' => $payment_data['user_email'],
            'description' => $description,
        );
        $request = $gateWay->paymentRequest($params);

        if ($request['status']) {
            edd_insert_payment_note($payment, 'شماره پرداخت : '.$request['paymentNumber']);
            wp_redirect($gateWay->getGatewayUrl().'/'.$request['paymentNumber']);
            exit;
        } else {
            wp_die('خطا - متاسفانه مشکلی در اتصال به درگاه پرداخت وجود دارد - ' . $request['message']);
            exit;
        }
    } else {
        edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
    }
}

add_action('edd_gateway_gateway', 'gateway_process');

function gateway_verify()
{
    global $edd_options;
    if (isset($_GET['verify']) && $_GET['verify'] == 'gateway' && isset($_POST['paymentNumber'])) {

        $payment_id = $_SESSION['edd_gateway_record'];

        if ($_POST['status'] == 1) {

            $gateway = new GateWay();
            $params = array(
                'merchantCode' => $edd_options['gateway_merchant'],
                'paymentNumber' => esc_attr($_POST['paymentNumber']),
            );
            $request = $gateway->paymentVerify($params);
            edd_empty_cart();

            if ($request['status']) {
                //update_post_meta( $payment, '_edd_payment_ppalrefnum',$Refnumber);
                edd_insert_payment_note($payment_id, 'بازگشت موفق، شماره پرداخت: '.$_POST['paymentNumber']);
                edd_update_payment_status($payment_id, 'publish');
                edd_send_to_success_page();
            } else {
                edd_update_payment_status($payment_id, 'failed');
                wp_redirect(get_permalink($edd_options['failure_page']));
            }
            exit;
        } else {
            edd_update_payment_status($payment_id, 'revoked');
            wp_redirect(get_permalink($edd_options['failure_page']));
            exit;
        }
    }
}

add_action('init', 'gateway_verify');

function gateway_settings($settings)
{
    $gateway_options = array(
        array(
            'id' => 'gateway_settings',
            'type' => 'header',
            'name' => '<strong>تنظیمات درگاه بهبانک</strong>'
        ),
        array(
            'id' => 'gateway_title',
            'type' => 'text',
            'name' => 'عنوان درگاه',
            'desc' => 'عنوانی که کاربر در صفحه سبد خرید مشاهده می کند را وارد کنید'
        ),
        array(
            'id' => 'gateway_merchant',
            'type' => 'text',
            'name' => 'مرچنت‌کد',
            'desc' => 'مرچنت کد درگاه بهبابنک خود را وارد کنید'
        ),
    );

    return array_merge($settings, $gateway_options);
}

add_filter('edd_settings_gateways', 'gateway_settings');
